ChatReadonlyProperties:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор чата
      example: 1
ChatFillableProperties:
  type: object
  properties:
    user_id:
      type: integer
      description: Идентификатор пользователя
      example: 42
    user_type:
      description: Тип пользователя
      allOf:
        - type: integer
        - $ref: '../../enums/user_type_enum.yaml'
    direction:
      description: Направление чата
      allOf:
        - type: integer
        - $ref: '../../enums/chat_direction_enum.yaml'
    type_id:
      type: integer
      description: Тип чата
    theme:
      type: string
      description: Тема чата
      example: Поддержка
    muted:
      type: boolean
      description: Флаг чата без ответов
      example: false
    unread_user:
      type: boolean
      description: Флаг непрочтении юзером
      example: false
    unread_admin:
      type: boolean
      description: Флаг непрочтении админом
      example: true
ChatRequiredProperties:
  type: object
  required:
    - user_id
Chat:
  allOf:
    - $ref: '#/ChatReadonlyProperties'
    - $ref: '#/ChatFillableProperties'
    - $ref: '#/ChatIncludes'
ChatForCreate:
  allOf:
    - $ref: '#/ChatFillableProperties'
    - $ref: '#/ChatRequiredProperties'
ChatForPatch:
  allOf:
    - $ref: '#/ChatFillableProperties'
SearchChatsFilter:
  type: object
  properties:
    id:
      type: integer
      description: Идентификатор чата
      example: 6
    user_id:
      type: integer
      description: Идентификатор пользователя
      example: 42
    type_id:
      type: integer
      description: Тип чата
    user_type:
      description: Тип пользователя
      allOf:
        - type: integer
        - $ref: '../../enums/user_type_enum.yaml'
    unread_admin:
      type: boolean
      description: Флаг непрочтении админом
      example: true
SearchChatsRequest:
  type: object
  properties:
    sort:
      $ref: '../../common_schemas.yaml#/RequestBodySort'
    filter:
      $ref: '#/SearchChatsFilter'
    include:
      $ref: '../../common_schemas.yaml#/RequestBodyInclude'
    pagination:
      $ref: '../../common_schemas.yaml#/RequestBodyPagination'
ChatIncludes:
  type: object
  properties:
    messages:
      type: array
      items:
        $ref: './messages.yaml#/Message'

ChatResponse:
  type: object
  properties:
    data:
      $ref: '#/Chat'
    meta:
      type: object
  required:
    - data
SearchChatsResponse:
  type: object
  properties:
    data:
      type: array
      items:
        $ref: '#/Chat'
    meta:
      type: object
      properties:
        pagination:
          $ref: '../../common_schemas.yaml#/ResponseBodyPagination'
  required:
    - data
    - meta
